!  LPTPort.f90 
!  Copyright (c) 1997-2002 Zeal SoftStudio.
!  E-Mail: support@zealsoftstudio.com
!  Web: http://www.zealsoftstudio.com
!  This sample illustrates how to use NTPort Library to 
!  get LPT ports address.
!
!  FUNCTIONS:
!   WinMain()      - Entry point for the application;
!                    displays the main window; processes the message loop
!   LPTPortSub()  - Callback routine for the main dialog box
!   LPTPortApply()- Callback routine for the APPLY button
!

!****************************************************************************
!
!  FUNCTION: WinMain( hInstance, hPrevInstance, lpszCmdLine, nCmdShow )
!
!  PURPOSE:  Entry point for the application
!
!  COMMENTS: Displays the main window and processes the message loop
!
!****************************************************************************
include '../ntport.f90'

integer*4 function WinMain( hInstance, hPrevInstance, lpszCmdLine, nCmdShow )
!DEC$ IF DEFINED(_X86_)
!DEC$ ATTRIBUTES STDCALL, ALIAS : '_WinMain@16' :: WinMain
!DEC$ ELSE
!DEC$ ATTRIBUTES STDCALL, ALIAS : 'WinMain' :: WinMain
!DEC$ ENDIF

    use user32
    use kernel32
    use dflogm
    use LPTPortGlobals

    implicit none

    integer*4 hInstance
    integer*4 hPrevInstance
    integer*4 lpszCmdLine
    integer*4 nCmdShow

    include 'resource.fd'

    external LPTPortSub
    external LPTPortApply

    ! Variables
    type (T_MSG)            mesg
    integer*4               ret
    logical*4               lret


    ghInstance = hInstance
    ghModule = GetModuleHandle(NULL)
    ghwndMain = NULL

    lret = DlgInit(IDD_LPTPORT_DIALOG, gdlg)
    if (lret == .FALSE.) goto 99999
    lret = DlgSetSub(gdlg, IDD_LPTPORT_DIALOG, LPTPortSub)
    lret = DlgSetSub(gdlg, IDM_APPLY, LPTPortApply)
    lret = DlgModeless(gdlg, nCmdShow)
    if (lret == .FALSE.) goto 99999

    ! Read and process messsages
    do while( GetMessage (mesg, NULL, 0, 0) ) 
	   if ((mesg.message .EQ. WM_COMMAND ).AND.( mesg.wParam .EQ. 2))then
	      return 
	   end if
       if ( DlgIsDlgMessage(mesg) .EQV. .FALSE. ) then
           lret = TranslateMessage( mesg )
           ret  = DispatchMessage( mesg )
       end if
    end do
    call DlgUninit(gdlg)

    WinMain = mesg.wParam
    return

99999 &

    ret = MessageBox(ghwndMain, "Error initializing application LPTPort"C, &
                     "Error"C, MB_OK)
    WinMain = 0

end 

!****************************************************************************
!
!  FUNCTION: LPTPortSub ( dlg, id, callbacktype )
!
!  PURPOSE:  Dialog box callback for initialization and destroy
!
!  COMMENTS:
!
!****************************************************************************

SUBROUTINE LPTPortSub( dlg, id, callbacktype )

  use user32
  use dflogm

  implicit none

  type (dialog) dlg
  integer id, callbacktype

  if (callbacktype == dlg_destroy) then
    call PostQuitMessage(0)
  endif

  END SUBROUTINE LPTPortSub

!****************************************************************************
!
!  FUNCTION: LPTPortApply ( dlg, id, callbacktype )
!
!  PURPOSE:  Dialog box callback for APPLY button
!
!  COMMENTS:
!
!****************************************************************************

SUBROUTINE LPTPortApply( dlg, id, callbacktype )

  use dflogm
  use ntport   !To use the NTportlibrary


  implicit none
  include 'resource.fd'

  type (dialog) dlg
  integer id, callbacktype

  logical retlog
  integer nAddress , i , nError
  character (len=100)ch ,s
 
  retlog = DlgSet( dlg, IDC_LISTBOX1, 3 )
  if (callbacktype == dlg_clicked) then
    do  i = 1 ,  3 
	    !Get LPT address
        nAddress = GetLPTPortAddress(i)
        nError = GetLastState(s)
        if(nAddress .GT. 0) then 
            write(ch,100),i,nAddress
100			format(" LPT",1i,Z5,'H')
        else if(nError .NE. 0) then
            write(ch,*)"LPT",i,"Error"
        else
            write(ch,*)"LPT",i," absent"
		end if 
	    retlog = DlgSet( dlg, IDC_LISTBOX1, ch, i )
	  end do

  end if

  END SUBROUTINE LPTPortApply


