!  PortTest.f90 
!  Copyright (c) 1997-2002 Zeal SoftStudio.
!  E-Mail: support@zealsoftstudio.com
!  Web: http://www.zealsoftstudio.com
!  This sample illustrates how to use NTPort
!  Library to read or write PC I/O ports.
!
!  FUNCTIONS:
!   WinMain()      - Entry point for the application;
!                    displays the main window; processes the message loop
!   PortTestSub()  - Callback routine for the main dialog box
!   PortTestApply()- Callback routine for the APPLY button
!

!****************************************************************************
!
!  FUNCTION: WinMain( hInstance, hPrevInstance, lpszCmdLine, nCmdShow )
!
!  PURPOSE:  Entry point for the application
!
!  COMMENTS: Displays the main window and processes the message loop
!
!****************************************************************************
include '../ntport.f90'



integer*4 function WinMain( hInstance, hPrevInstance, lpszCmdLine, nCmdShow )
!DEC$ IF DEFINED(_X86_)
!DEC$ ATTRIBUTES STDCALL, ALIAS : '_WinMain@16' :: WinMain
!DEC$ ELSE
!DEC$ ATTRIBUTES STDCALL, ALIAS : 'WinMain' :: WinMain
!DEC$ ENDIF

    use user32
    use kernel32
    use dflogm
    use PortTestGlobals
	use ntport   !To use the NTportlibrary


    implicit none

    integer*4 hInstance
    integer*4 hPrevInstance
    integer*4 lpszCmdLine
    integer*4 nCmdShow

    include 'resource.fd'

    external PortTestSub
    external PortTestApply
    external PortTestRead
    external PortTestWrite


    ! Variables
    type (T_MSG)            mesg
    integer*4               ret
    logical*4               lret

	index = 1 !listbox index
    ghInstance = hInstance
    ghModule = GetModuleHandle(NULL)
    ghwndMain = NULL

    lret = DlgInit(IDD_PORTTEST_DIALOG, gdlg)
    if (lret == .FALSE.) goto 99999
    lret = DlgSetSub(gdlg, IDD_PORTTEST_DIALOG, PortTestSub)
    lret = DlgSetSub(gdlg, IDM_APPLY, PortTestApply)
    lret = DlgSetSub(gdlg, IDM_Read, PortTestRead)
	lret = DlgSetSub(gdlg, IDM_Write, PortTestWrite)
	lret = DlgSet(gdlg, IDC_RADIOByte , .TRUE.)
	lret = DlgSet(gdlg, IDC_EDITPort , "20")
	lret = DlgSet( gdlg, IDC_LISTBOX1, 40)

	lret = DlgSetSub(gdlg, IDM_APPLY, PortTestApply)
    lret = DlgModeless(gdlg, nCmdShow)
    if (lret == .FALSE.) goto 99999
    
	! Place your registration information here
	call LicenseInfo("Your Name", 0)

    ! Read and process messsages
    do while( GetMessage (mesg, NULL, 0, 0) ) 
	   if ((mesg.message .EQ. WM_COMMAND ).AND.( mesg.wParam .EQ. 2))then
	      return 
	   end if
       if ( DlgIsDlgMessage(mesg) .EQV. .FALSE. ) then
           lret = TranslateMessage( mesg )
           ret  = DispatchMessage( mesg )
       end if
    end do
    call DlgUninit(gdlg)

    WinMain = mesg.wParam
    return

99999 &

    ret = MessageBox(ghwndMain, "Error initializing application PortTest"C, &
                     "Error"C, MB_OK)
    WinMain = 0

end 

!****************************************************************************
!
!  FUNCTION: PortTestSub ( dlg, id, callbacktype )
!
!  PURPOSE:  Dialog box callback for initialization and destroy
!
!  COMMENTS:
!
!****************************************************************************

SUBROUTINE PortTestSub( dlg, id, callbacktype )

  use user32
  use dflogm

  implicit none

  type (dialog) dlg
  integer id, callbacktype

  if (callbacktype == dlg_destroy) then
    call PostQuitMessage(0)
  endif

  END SUBROUTINE PortTestSub

!****************************************************************************
!  FUNCTION: PortTestApply ( dlg, id, callbacktype )
!  PURPOSE:  Dialog box callback for APPLY button
!  COMMENTS:
!****************************************************************************
SUBROUTINE PortTestApply( dlg, id, callbacktype )

  use dflogm

  implicit none

  type (dialog) dlg
  integer id, callbacktype

  if (callbacktype == dlg_clicked) then
    ! TO DO; Add your APPLY logic here
  endif

  END SUBROUTINE PortTestApply


!****************************************************************************
!  FUNCTION: PortTestRead ( dlg, id, callbacktype )
!  PURPOSE:  Dialog box callback for read data button
!  COMMENTS:
!****************************************************************************
SUBROUTINE PortTestRead( dlg, id, callbacktype )

  use dflogm
  use ntport
  use PortTestGlobals

  implicit none
  include 'resource.fd'
  type (dialog) dlg
  integer id, callbacktype
  integer PortAddress  ,temp
  integer(4) value 

  character(len=50) text , porttext
  character (100) textstate
  logical flagbyte , flagword,lret
  
   value = 0


  if (callbacktype == dlg_clicked) then
    ! TO DO; Add your APPLY logic here
	   !get portaddress
	   lret = DlgGet(dlg,IDC_EDITPort,porttext)
	   if (LEN(porttext) .GT. 0) then
			read (porttext, 100) PortAddress
100         format(Z8)
	   else 
			PortAddress = Z'20'
	   end if
	
	   !
	   lret= DlgGet(dlg ,IDC_RADIOByte,flagbyte)
	   lret= DlgGet(dlg ,IDC_RADIOWord,flagword)
	   if ( flagbyte ) then
		   !read the data  in the mode of byte
		   value = Inport(PortAddress)
	   else if ( flagword ) then
		   value = InportW(PortAddress)
			!read data in the mode of word
	   else
		   value = InportD(PortAddress)
	   end if
	   !show data in listbox
       write(text,200)PortAddress,value
200	   format(" In 0x",Z8,'  : ',Z8,'H')
	   lret = DlgSet( dlg, IDC_LISTBOX1, text, index )
	   index = index + 1
	   temp = GetLastState(textstate)
    	lret = DlgSet( dlg, IDC_LISTBOX1, textstate, index )
	   index = index + 1
  endif

  END SUBROUTINE PortTestRead

!****************************************************************************
!  FUNCTION: PortTestWrite ( dlg, id, callbacktype )
!  PURPOSE:  Dialog box callback for write data to port button
!  COMMENTS:
!****************************************************************************
SUBROUTINE PortTestWrite( dlg, id, callbacktype )

  use dflogm
  use PortTestGlobals
  use ntport

  implicit none
  include 'resource.fd'

  type (dialog) dlg
  integer id, callbacktype
  integer PortAddress  ,temp
  integer(4) value 
  character (len=100) text ,textstate

  logical flagbyte , flagword,lret

  if (callbacktype == dlg_clicked) then
    ! TO DO; Add your APPLY logic here
	!get port address
	   lret = DlgGet(dlg,IDC_EDITPort,text)
			read (text, 300) PortAddress
300         format(Z8)

	   !get output value
	   lret = DlgGet(dlg,IDC_EDITdata,text)
			read (text, 400) value
400         format(Z8)


	   !output data
	   lret= DlgGet(dlg ,IDC_RADIOByte,flagbyte)
	   lret= DlgGet(dlg ,IDC_RADIOWord,flagword)
	   if ( flagbyte ) then
		   !write the data  in the mode of byte
		   call Outport(PortAddress,value)
	   else if ( flagword ) then
		   call OutportW(PortAddress,value)
			!write data in the mode of word
	   else
		   call OutportD(PortAddress,value)
	   end if
	   !show data in listbox
       write(text,500)PortAddress,value
500	   format(" Out 0x",Z8,'  : ',Z8,'H')
	   lret = DlgSet( dlg, IDC_LISTBOX1, text, index )
	   index = index + 1
	   temp = GetLastState(textstate)
	   lret = DlgSet( dlg, IDC_LISTBOX1, textstate, index )
	   index = index + 1

  endif

  END SUBROUTINE PortTestWrite