! NTPort Library interface 
! Copyright (c) 1997-2002 Zeal SoftStudio.
! E-Mail: support@zealsoftstudio.com
! Web: http://www.zealsoftstudio.com

!DEC$ FREEFORM
!DEC$ IF .NOT. DEFINED(__ntport_INCLUDE)
MODULE ntport
!DEC$ ENDIF

!**** Define constant symbol ***
integer :: ERROR_NONE = 0
integer :: ERROR_DRIVER = 2
integer :: ERROR_SCM_CANT_CONNECT = 9998

interface

!****************Input functions***************************
! Read a byte
integer(4) function Inp(PortNum)
!DEC$ IF DEFINED(_X86_)
!DEC$ ATTRIBUTES STDCALL, ALIAS : '_Inp@4' :: Inp
!DEC$ ELSE
!DEC$ ATTRIBUTES STDCALL, ALIAS : 'Inp' :: Inp
!DEC$ ENDIF
integer(4) PortNum
end function

! Read a word
integer(4) function Inpw(PortNum)
!DEC$ IF DEFINED(_X86_)
!DEC$ ATTRIBUTES STDCALL, ALIAS : '_Inpw@4' :: Inpw
!DEC$ ELSE
!DEC$ ATTRIBUTES STDCALL, ALIAS : 'Inpw' :: Inpw
!DEC$ ENDIF
integer(4) PortNum
end function

! Read double word
integer(4) function Inpd(PortNum)
!DEC$ IF DEFINED(_X86_)
!DEC$ ATTRIBUTES STDCALL, ALIAS : '_Inpd@4' :: Inpd
!DEC$ ELSE
!DEC$ ATTRIBUTES STDCALL, ALIAS : 'Inpd' :: Inpd
!DEC$ ENDIF
integer(4) PortNum
end function

! Read a byte
integer(4) function Inport(PortNum)
!DEC$ IF DEFINED(_X86_)
!DEC$ ATTRIBUTES STDCALL, ALIAS : '_Inport@4' :: Inport
!DEC$ ELSE
!DEC$ ATTRIBUTES STDCALL, ALIAS : 'Inport' :: Inport
!DEC$ ENDIF
integer(4) PortNum
end function

! Read a word
integer(4) function InportW(PortNum)
!DEC$ IF DEFINED(_X86_)
!DEC$ ATTRIBUTES STDCALL, ALIAS : '_InportW@4' :: InportW
!DEC$ ELSE
!DEC$ ATTRIBUTES STDCALL, ALIAS : 'InportW' :: InportW
!DEC$ ENDIF
integer(4) PortNum
end function

! Read double word
integer(4) function InportD(PortNum)
!DEC$ IF DEFINED(_X86_)
!DEC$ ATTRIBUTES STDCALL, ALIAS : '_InportD@4' :: InportD
!DEC$ ELSE
!DEC$ ATTRIBUTES STDCALL, ALIAS : 'InportD' :: InportD
!DEC$ ENDIF
integer(4) PortNum
end function

!****************** End of input functions*******************




!******************* Output functions************************
! Write a byte
subroutine Outp(PortNum,data1)
!DEC$ IF DEFINED(_X86_)
!DEC$ ATTRIBUTES STDCALL, ALIAS : '_Outp@8' :: Outp
!DEC$ ELSE
!DEC$ ATTRIBUTES STDCALL, ALIAS : 'Outp' :: Outp
!DEC$ ENDIF
integer(4) PortNum,data1
end subroutine

! Write a word
subroutine Outpw(PortNum,data1)
!DEC$ IF DEFINED(_X86_)
!DEC$ ATTRIBUTES STDCALL, ALIAS : '_Outpw@8' :: Outpw
!DEC$ ELSE
!DEC$ ATTRIBUTES STDCALL, ALIAS : 'Outpw' :: Outpw
!DEC$ ENDIF
integer(4) PortNum,data1
end subroutine

! Write double word
subroutine Outpd(PortNum,data1)
!DEC$ IF DEFINED(_X86_)
!DEC$ ATTRIBUTES STDCALL, ALIAS : '_Outpd@8' :: Outpd
!DEC$ ELSE
!DEC$ ATTRIBUTES STDCALL, ALIAS : 'Outpd' :: Outpd
!DEC$ ENDIF
integer(4) PortNum,data1
end subroutine

! Write a byte
subroutine Outport(PortNum,data1)
!DEC$ IF DEFINED(_X86_)
!DEC$ ATTRIBUTES STDCALL, ALIAS : '_Outport@8' :: Outport
!DEC$ ELSE
!DEC$ ATTRIBUTES STDCALL, ALIAS : 'Outport' :: Outport
!DEC$ ENDIF
integer(4) PortNum,data1
end subroutine

! Write double word
subroutine OutportD(PortNum,data1)
!DEC$ IF DEFINED(_X86_)
!DEC$ ATTRIBUTES STDCALL, ALIAS : '_OutportD@8' :: OutportD
!DEC$ ELSE
!DEC$ ATTRIBUTES STDCALL, ALIAS : 'OutportD' :: OutportD
!DEC$ ENDIF
integer(4) PortNum,data1
end subroutine

! Write a word
subroutine OutportW(PortNum,data1)
!DEC$ IF DEFINED(_X86_)
!DEC$ ATTRIBUTES STDCALL, ALIAS : '_OutportW@8' :: OutportW
!DEC$ ELSE
!DEC$ ATTRIBUTES STDCALL, ALIAS : 'OutportW' :: OutportW
!DEC$ ENDIF
integer(4) PortNum,data1
end subroutine
!******************* End of output functions*******************


!********************** For port setting********************
!Enable your application to read or write specific ports.
subroutine EnablePorts(PortStart, PortStop)
!DEC$ IF DEFINED(_X86_)
!DEC$ ATTRIBUTES STDCALL, ALIAS : '_EnablePorts@8' :: EnablePorts
!DEC$ ELSE
!DEC$ ATTRIBUTES STDCALL, ALIAS : 'EnablePorts' :: EnablePorts
!DEC$ ENDIF
integer(4) PortStart
integer(4)  PortStop
end subroutine

!Disable your application to read or write specific ports.
subroutine DisablePorts(PortStart, PortStop)
!DEC$ IF DEFINED(_X86_)
!DEC$ ATTRIBUTES STDCALL, ALIAS : '_DisablePorts@8' :: DisablePorts
!DEC$ ELSE
!DEC$ ATTRIBUTES STDCALL, ALIAS : 'DisablePorts' :: DisablePorts
!DEC$ ENDIF
integer(4) PortStart
integer(4)  PortStop
end subroutine

!Set the setting of fast mode
subroutine SetFastMode(bOption1)
!DEC$ IF DEFINED(_X86_)
!DEC$ ATTRIBUTES STDCALL, ALIAS : '_SetFastMode@4' :: SetFastMode
!DEC$ ELSE
!DEC$ ATTRIBUTES STDCALL, ALIAS : 'SetFastMode' :: SetFastMode
!DEC$ ENDIF
logical  bOption1
end subroutine

!Get the current setting of fast mode
logical function GetFastMode()
!DEC$ IF DEFINED(_X86_)
!DEC$ ATTRIBUTES STDCALL, ALIAS : '_GetFastMode@0' :: GetFastMode
!DEC$ ELSE
!DEC$ ATTRIBUTES STDCALL, ALIAS : 'GetFastMode' :: GetFastMode
!DEC$ ENDIF
end function

!**********************End of  port setting********************
!Set the registration information.
subroutine LicenseInfo(sUserName, sKey)
!DEC$ IF DEFINED(_X86_)
!DEC$ ATTRIBUTES STDCALL, ALIAS : '_LicenseInfo@8' :: LicenseInfo
!DEC$ ELSE
!DEC$ ATTRIBUTES STDCALL, ALIAS : 'LicenseInfo' :: LicenseInfo
!DEC$ ENDIF
!DEC$ ATTRIBUTES REFERENCE :: sUserName
character *(*) sUserName
integer(4)  sKey
end subroutine

!Returns a value indicates whether the application is running under Windows NT/2000 system.
logical function IsWinNT()
!DEC$ IF DEFINED(_X86_)
!DEC$ ATTRIBUTES STDCALL, ALIAS : '_IsWinNT@0' :: IsWinNT
!DEC$ ELSE
!DEC$ ATTRIBUTES STDCALL, ALIAS : 'IsWinNT' :: IsWinNT
!DEC$ ENDIF
end function

!Returns the version of NTPort Library.
integer function GetNTPortVersion()
!DEC$ IF DEFINED(_X86_)
!DEC$ ATTRIBUTES STDCALL, ALIAS : '_GetNTPortVersion@0' :: GetNTPortVersion
!DEC$ ELSE
!DEC$ ATTRIBUTES STDCALL, ALIAS : 'GetNTPortVersion' :: GetNTPortVersion
!DEC$ ENDIF
end function

!Get the base address of LPT port
integer function GetLPTPortAddress(PortNo)
!DEC$ IF DEFINED(_X86_)
!DEC$ ATTRIBUTES STDCALL, ALIAS : '_GetLPTPortAddress@4' :: GetLPTPortAddress
!DEC$ ELSE
!DEC$ ATTRIBUTES STDCALL, ALIAS : 'GetLPTPortAddress' :: GetLPTPortAddress
!DEC$ ENDIF
integer PortNo
end function

!Returns a value indicating the last operation is successful or not.
integer function GetLastState(s)
!DEC$ IF DEFINED(_X86_)
!DEC$ ATTRIBUTES STDCALL, ALIAS : '_GetLastState@4' :: GetLastState
!DEC$ ELSE
!DEC$ ATTRIBUTES STDCALL, ALIAS : 'GetLastState' :: GetLastState
!DEC$ ENDIF
!DEC$ ATTRIBUTES REFERENCE :: s
character *(*) s

end function

end interface

!DEC$ IF .NOT. DEFINED(__ntport_INCLUDE)
END MODULE ntport
!DEC$ ENDIF

